
Ruby - Bug #13776

Refined methods ignore visibility of inherited methods

07/29/2017 09:19 AM - Mon_Ouie (Mon ouïe)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.0dev (2017-07-28 trunk 59438)

[x86_64-linux]

Backport: 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

Description

This bug was pointed out by al2o3-cr on the #ruby IRC channel on freenode. The following code sleeps for 3 seconds, even though

String#sleep is a private method.

module Test

  refine String do

    def sleep; end

  end

end

puts "start"

"".sleep 3

puts "end"

 This happens because vm_call_method_each_type, when running a method of type VM_METHOD_TYPE_REFINED, uses

vm_call_zsuper to call inherited methods, which does not check the visibility of the method and directly executes it. I attached a

patch which changes this code path and uses vm_call_method to trigger the code that honors method visibilities. I have not played

extensively with this patch, but it at least does not seem to break any existing unit tests.

Associated revisions

Revision 3449d4fa2d2ac0655eb55a770aa10fc829660760 - 07/29/2017 12:42 PM - nobu (Nobuyoshi Nakada)

visibility of inherited method

vm_insnhelper.c (vm_call_method_each_type): honor the original

visibility of inherited methods when a refinement is defined but

not activated.  [ruby-core:82209] [Bug #13776]

Author:    Mon_Ouie (Mon ouïe) mon.ouie@gmail.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59445 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3449d4fa - 07/29/2017 12:42 PM - nobu (Nobuyoshi Nakada)

visibility of inherited method

vm_insnhelper.c (vm_call_method_each_type): honor the original

visibility of inherited methods when a refinement is defined but

not activated.  [ruby-core:82209] [Bug #13776]

Author:    Mon_Ouie (Mon ouïe) mon.ouie@gmail.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59445 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision db22ab157503ac1417a3d63aaaf6bbe159decea7 - 12/24/2017 02:29 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 59444,59445: [Backport #13776]

    adjust indent [ci skip]

    * vm_insnhelper.c (vm_call_method_each_type): adjust indent of a

      block in switch.

    visibility of inherited method

    * vm_insnhelper.c (vm_call_method_each_type): honor the original
      visibility of inherited methods when a refinement is defined but

      not activated.  [ruby-core:82209] [Bug #13776]

    Author:    Mon_Ouie (Mon ouie) <mon.ouie@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@61436 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision db22ab15 - 12/24/2017 02:29 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 59444,59445: [Backport #13776]

    adjust indent [ci skip]

    * vm_insnhelper.c (vm_call_method_each_type): adjust indent of a

      block in switch.

    visibility of inherited method

    * vm_insnhelper.c (vm_call_method_each_type): honor the original

      visibility of inherited methods when a refinement is defined but

      not activated.  [ruby-core:82209] [Bug #13776]

    Author:    Mon_Ouie (Mon ouie) <mon.ouie@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@61436 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1aee5acdae7fa88e0241ed4c21ed88f775054cba - 01/31/2018 01:13 PM - U.Nakamura 

merge revision(s) 59444,59445: [Backport #13776]

    adjust indent [ci skip]

    * vm_insnhelper.c (vm_call_method_each_type): adjust indent of a

      block in switch.

    visibility of inherited method

    * vm_insnhelper.c (vm_call_method_each_type): honor the original

      visibility of inherited methods when a refinement is defined but

      not activated.  [ruby-core:82209] [Bug #13776]

    Author:    Mon_Ouie (Mon ouie) <mon.ouie@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62134 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1aee5acd - 01/31/2018 01:13 PM - U.Nakamura 

merge revision(s) 59444,59445: [Backport #13776]

    adjust indent [ci skip]

    * vm_insnhelper.c (vm_call_method_each_type): adjust indent of a

      block in switch.

    visibility of inherited method

    * vm_insnhelper.c (vm_call_method_each_type): honor the original

      visibility of inherited methods when a refinement is defined but

      not activated.  [ruby-core:82209] [Bug #13776]

    Author:    Mon_Ouie (Mon ouie) <mon.ouie@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62134 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/29/2017 12:42 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r59445.

visibility of inherited method
vm_insnhelper.c (vm_call_method_each_type): honor the original

visibility of inherited methods when a refinement is defined but

not activated.  [ruby-core:82209] [Bug #13776]

Author:    Mon_Ouie (Mon ouïe) mon.ouie@gmail.com

#2 - 07/29/2017 12:46 PM - nobu (Nobuyoshi Nakada)

- Description updated

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED

#3 - 12/24/2017 02:29 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE

ruby_2_4 r61436 merged revision(s) 59444,59445.

#4 - 01/31/2018 01:13 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE to 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

ruby_2_3 r62134 merged revision(s) 59444,59445.

Files

refinement.patch 1.74 KB 07/29/2017 Mon_Ouie (Mon ouïe)
